local SERVER_ID = 1       -- 服务器标识
local MAX_CLIENT = 8000   -- 最大连接数限制

local GAME_PORT = 8002    -- 向客户开放的游戏端口
local WEB_PORT = 9002     -- 向WEB开放的控制端口
local CONSOLE_PORT = 7002 -- 控制台端口

local REDIS_HOST = "127.0.0.1"    -- 数据库主机ip地址
local REDIS_PORT = 6002               -- 数据库端口
local REDIS_AUTH = 'xh123'          -- 数据库密码

local WEB_HOST = "0.0.0.0"

option = {
  sid = SERVER_ID,
  game_port = GAME_PORT,
  web_port = WEB_PORT,
  console_port = CONSOLE_PORT,
  max_client = MAX_CLIENT,
  web_host = WEB_HOST,
  redis = {
    auth = REDIS_AUTH,
    host = REDIS_HOST,
    port = REDIS_PORT,
  },
  cluster_redis = {
    auth = REDIS_AUTH,
    host = REDIS_HOST,
    port = 7000,
  },
}

-- 集群地址配置
CLUSTER = {
  watchdog = "127.0.0.1:10001", -- 接受集群推送
  master = "127.0.0.1:12000",
}

-- 集群启动使用参数
MASTER_CONF = {
  debug_port = 5558,
  web_port = 5559,
}

-- 服务器启动相关参数
LAUNCH = {
  maintain = false,           -- true:维护 false:开放
  battle_log = true,         -- true:开启战斗日志 false:关闭战斗日志
  white_list = {
      --[222.212.88.4] = true -- true: 白名大 false: 黑名单
  },
  debug_battle = true,        -- true:战斗调试开启 false: 战斗调试关闭
}

RECHARGE_SERVICE = "127.0.0.1:8081"
