--玩家封测返利
local schema = require "model.schema"
local logger = require "logger"
local mailbox = require "model.mailbox"
local asset = require "model.asset"
local reward = require "model.reward"
local util     = require "util"
local stringify = require "stringify"

local trace = logger.trace
--local trace = function(...) end

local _M = schema.new('pay_feedback', {
    receive = 0,--玩家是否获取过回馈奖励
    recharge = 0,--玩家充值活动返还
    android = nil,-- 正版安卓返利使用
})
local pay_feedback = {}

local channel = {
--   ["sy185"] = function (...) pay_feedback.BT_rebate(...) end,
  ["pengling"] = function(...) pay_feedback.android_rebate(...) end,
  ["wyhd_ysdk"] = function(...) pay_feedback.android_rebate(...) end,
  ["pengling_wy"] = function(...) pay_feedback.android_rebate(...) end,
  ["pengling_wy1"] = function(...) pay_feedback.android_rebate(...)end,
  ["pengling_wy2"] = function(...) pay_feedback.android_rebate(...)end,
  ["pengling_wy3"] = function(...) pay_feedback.android_rebate(...)end,
  ["editor"] = function (...) pay_feedback.android_rebate(...)end,
}

function pay_feedback.parse(character)
  _M.load(character)
end

function pay_feedback.betarewards(character,payrebate)
  if payrebate.diamonds and payrebate.diamonds > 0 then
    local awacfg = {diamonds = payrebate.diamonds}
    -- mailbox.send(character, 25, nil, awacfg, {
    --     module = "pay_feedback",
    --     brief = "封测返利",
    --     context=string.format("钻石:%s", payrebate.diamonds),
    -- })

    local desc = {
      module="pay_feedback",
      brief="封测返利",
      notify={flags="pay_feedback.betarewards"},
      detail= awacfg                 -- 奖励
    }
    reward(character, desc)
  end
  if payrebate.vipexp and payrebate.vipexp > 0 then
    character.dispatch("diamond.accumulate",payrebate.vipexp,_,payrebate.RMB) --派发增加vip经验
  end

end

function pay_feedback.recharge_player(character,payrebate)
  if payrebate.RMB and payrebate.RMB > 0 then
    -- local recharge7day = require "model.activity.recharge7day"
    -- local daily_recharge = require "model.activity.daily_recharge"
    -- local recharge = require "model.rechargemod"
    -- recharge7day.sy185set_money(character,payrebate.RMB)
    -- daily_recharge.sy185set_money(character,payrebate.RMB)
    -- recharge.sy185set_money(character)
    trace("185封测充值返利获得充值数据已结束")
  end
end

function pay_feedback.BT_rebate(character)
  -- trace("_________________aaaa:%s",stringify(aa))
  local account = tostring(character.account)
  local infopayrebate = asset.payrebate_proto[account]
  if not infopayrebate then
    if not infopayrebate then
      trace("%s:非首测充值玩家",account)
      return
    end
  end

  local state = 0
  local d = _M.assert_get(character)
  local receive = d.receive or 0
  if receive == 0 then
    pay_feedback.betarewards(character,infopayrebate)
    d.receive = 1
    state = 1
  else
    trace("已发送首测充值返利奖励")
  end

  local recharge = d.recharge or 0
  if recharge == 0 then
    pay_feedback.recharge_player(character,infopayrebate)
    d.recharge = 1
    state = 1
  else
    trace("已发送recharge首测充值返利奖励")
  end
end

-- 正版安卓
function pay_feedback.android_rebate(character)
  local d = _M.assert_get(character)
  logger.trace(" ------------------- %s", stringify(d))
  local account = tostring(character.account)
  local infopayrebate = asset.payrebate_proto[account]
  if not infopayrebate then
    trace("%s:非首测充值玩家",account)
    return
  end
  local tm = util.today()
  if not d.android then
    d.android = {
      next = tm + 7*86400,                -- 第八天，返还剩余的
      sign = false,                       -- 快捷标记
      residue = math.floor(infopayrebate.diamonds/2),   -- 玩家剩余返回的钻石
    }
    local desc = {
      module="pay_feedback",
      brief="封测返利 第一次",
      notify={flags="pay_feedback.android_rebate"},
      detail= {
        diamonds = math.floor(infopayrebate.diamonds/2)
      }                 -- 奖励
    }
    logger.trace(" ------------------- 给玩家返回砖石1 %s",math.floor(infopayrebate.diamonds/2))
    reward(character, desc)
    _M.persist(character)
    return
  end

  if d.android.sign then
    logger.trace(" --------------------- 玩家已经领完返还钻石")
    return
  end
  -- 返回剩余
  if os.time() >= d.android.next then
--   if os.time() ~= d.android.next then
    local diamonds = d.android.residue
    d.android.residue = 0
    d.android.sign = true
    _M.persist(character)
    local desc = {
      module="pay_feedback",
      brief="封测返利 第二次",
      notify={flags="pay_feedback.android_rebate"},
      detail= {
        diamonds = diamonds
      }                 -- 奖励
    }
    logger.trace(" ------------------- 给玩家返回砖石2 %s",math.floor(infopayrebate.diamonds/2))
    reward(character, desc)
    return
  end
end

function pay_feedback.ready(character)
  local serverid = option.sid
  if serverid ~= 1 then
    trace("非首发服务器")
    return
  end
  if channel[character.channel] then
    channel[character.channel](character)
  else
    trace("非返利渠道")
    return
  end

  if state == 1 then
   _M.persist(character)
  end
end

return pay_feedback